> For the complete documentation index, see [llms.txt](https://developer.collibra.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.collibra.com/api/guides/output-module/api-endpoints-and-query-formats/csv-output-format.md).

# CSV output format

When exporting data to CSV, all newline characters are converted to spaces. This applies to every column, including asset names, descriptions, and plain-text attribute values.

## Limits

To protect Collibra against extensive memory usage from a single query, global limits are applied:

`rootNodesNumberLimit`

The maximum number of root nodes sets the maximum value for the `displayLength` parameter to 100,000.

* By default, this limit is disabled in all environments.
* However, we recommend enabling it and using smaller `displayLength` values to ensure a single query does not overuse system resources.

`pageNodesNumberLimit`

The maximum number of nodes per page sets the maximum number of both root and child nodes to 1,000,000.

* This limit is always enabled.
* All graph queries are internally paged with a page size of 5,000 to produce the full result and return it to the API user.
* This limit is applied per page.

For endpoints that produce results directly in the response, without creating a file or job, reaching the limit could result in partial responses with a 200 OK HTTP status code. This occurs because results are streamed directly to the response to optimize performance.

{% hint style="success" %}
You can change the default values for these limits in Collibra Console in the [**Graph query limits** section](https://productresources.collibra.com/docs/collibra/latest/Content/Console/Infrastructure/DGCService/Configuration/ref_environment-settings.htm#graph-query-limits).
{% endhint %}
